# OpenVPN AutoConnector

## Description

Why is this even written?

The basic idea for the script lies within openvpn itself. I've experienced that openvpn sometimes drops the connection silently, which means you end up with a dead openvpn-client-link. This scripts does what openvpn don't do itself, possibly with a bit bulky code:

* The script starts with looking for a valid PID and checks if openvpn is up and running on that PID. If not, it tries to start up.
* If the script discovers a process on the PID, it now looks for an interface to ping on.
* If the ping fails, the interface is down even if the client is up, or something like this it knows the link is dead. In that case, it tries to kill the client and restart it.


## The HOWTO

Base location for this connector script is /etc/openvpn - since the script was once written to handle ovpn.com-uplinks, it will scan through any directory with the name ovpn or openvpn. By running just the command without parameters will render a list like this:

    openvpn-mail01
    openvpn-tunnel02

As it was written for OVPN the directory structure also may look like this:

    ovpn-firstaccount-se-v4
    ovpn-firstaccount-de-v4
    ovpn-secondaccount-us
    ovpn-thirdaccount-uk

By means, the script will divide each hyphen as an extra parameter, which means that you can have one account with different connection locations. For example:

    ovpn firstaccount se v4
    
This is a legacy setup that starts up the tunnel that resides in. It's simple as that.

    ovpn-firstaccount-se-v4
    
In each directory, the default configuration lookup is based on conf (but should support ovpn extensions too). As some of the configuration services may require pre-running scripts, it also checks for a prerun.sh - example:

You want a safe killswitch, so prerun.sh runs before openvpn fires up, to make sure there are default routes prepared. Your script in that case could look like this:

    ip route del default >/dev/null 2>&1
    ip route add default via 192.168.1.1
    ip route del 1.2.3.4/24 via 192.168.1.1 >/dev/null 2>&1
    ip route add 1.2.3.4/24 via 192.168.1.1

This makes sure that there are are a default route while openvpn tries to connect. It also makes sure that the VPN ip-address keeps going through the default gateway. As soon as openvpn runs and the up-scripts (defined by you, in the configuration), the default gateway can be removed. Observe that this is only an example of a "killswitch-like" environment. So to explain this further, you have those rows added in your configuration file:

    up /etc/openvpn/ovpn-firstaccount-se-v4/goup
    down /etc/openvpn/ovpn-firstaccount-se-v4/godown

### goup content:

    #!/bin/bash
    dev=$1
    rt=$4
    ip route del default >/dev/null 2>&1
    ip route add default via $rt dev $dev

The script itself takes advantage of openvpn startup parameters for scripts and makes sure that the default gateway are replaced by the VPN. Normally OpenVPN supports default gatewaying itself, but this can also be used to tweak your connection. For example, if you want to make use of both your own link and the VPN connection the same time, the goup can be used for this. For example:

    #!/bin/bash
    dev=$1
    rt=$4
    ip route del default >/dev/null 2>&1
    ip route add default via $rt dev $dev
    ip rule add from 192.168.1.0/24 table 192
    ip route add default via 192.168.1.1 table 192

This (eventually) makes sure that your connectivity takes the correct routes.

### godown content

    #!/bin/bash
    ip route del default >/dev/null 2>&1

This one is simpler. Having a killswitch as one of the examples above explains, this makes sure that the default route are removed as soon as openvpn drops the connection. However, this might not work if you involve default routes with metrics. But that's another story...

## I have openvpn as a server with not outbound connections

So you don't want to kill it unless the client isn't started itself? Just put a file in the configuration structure, named "server" and the checks will be handled a bit slopppier.
